package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.EmpresaCertificadoConfigDAO;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.EmpresaCertificadoConfig;
import com.rjconsultores.ventaboletos.enums.EnumTipoCertificado;

@Repository("empresaCertificadoConfigDAO")
public class EmpresaCertificadoConfigHibernateDAO extends GenericHibernateDAO<EmpresaCertificadoConfig, Integer>
		implements EmpresaCertificadoConfigDAO {

	@Autowired
	public EmpresaCertificadoConfigHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<EmpresaCertificadoConfig> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		return c.list();
	}

	@Override
	public EmpresaCertificadoConfig buscarPorEmpresa(Empresa empresa, EnumTipoCertificado enumTipoCertificado) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("empresa", empresa));
		c.add(Restrictions.eq("nome", enumTipoCertificado.toString()));

		return (EmpresaCertificadoConfig) c.uniqueResult();
	}
}
